/*LIP library - runtime support for irregular and ooc problems*/ 
/*correct.h -this file contains declarations of functions
 that are used by partitioner */

#ifndef _CORRECT_
#define CORRECT
#include <stdio.h>

int sortint(const void * a,const void * b);
int sortLD(const unsigned long*a,const unsigned long *b);
 
int merge_UL (unsigned long* outbuf,unsigned long * buf1,int count1,
unsigned long *buf2,int count2);

int merge (void* outbuf,void * buf1,int count1,
void *buf2,int count2,MPI_Datatype datatype);

void* chain_merge (void *mybuffer,int count,MPI_Datatype datatype);

int part_sort (int* sum_belongings,int count_bel,LIP_bucket_element *bucket,
                int count);

int correct(int left_sum_sizes,
	    LIP_bucket_element *bucket,
            int my_current_size,
	    int correct_size,LIP_IDatamap* irr_data);

#endif

